<template>
    <div id="map"></div>
</template>

<script>
import mapboxgl from 'mapbox-gl';

export default {
    name: "MapBox",
    data() {
        return {
            map: null,
        }
    },
    mounted() {
        const map = new mapboxgl.Map({
            container: 'map',
            accessToken: 'pk.eyJ1IjoiY2xrNTI4IiwiYSI6ImNqYjFpd212dzdiOGozM3J6c3Ixa2ZrcHMifQ.CWnW_Jg7etbYBx2voIuhWA',
            style: 'style.json',
            center: [121.5297146514058, 31.227887884840268],
            zoom: 19
        });

        map.addControl(new mapboxgl.NavigationControl());
        this.registerEvents(map);
        this.map = map;
    },
    methods: {
        registerEvents(map) {
            map.on('click', 'classroom-fill', a => {
                console.log(a.features[0])

                const feature = a.features[0];

                this.map.zoomTo(22, {
                    center: [a.lngLat.lng, a.lngLat.lat]
                });

                const {properties} = feature;

                if (properties.name === "小老妹办公室") {
                    this.map.setLayoutProperty("xiaolaomei-seat", "visibility", "visible");
                } else {
                    this.map.setLayoutProperty("xiaolaomei-seat", "visibility", "none");
                }
            });
        }
    }
}
</script>

<style scoped>
#map {
    height: 80%;
}
</style>
